<template>
    <h1>Forms</h1>
    <hr class="half-bar" />
    <div class="form-card-wrapper">
        <div
            class="form-card"
            v-for="form in forms"
            :key="form.name"
            v-on:click="openForm(form.uri)"
        >
            <h3>{{ form.name }}</h3>
            <p>({{ form.uri }})</p>
        </div>
    </div>
</template>

<script lang="ts">
import { Vue } from 'vue-class-component';
import axios from 'axios';

interface Form {
    name: string;
    uri: string;
}

export default class FormSelector extends Vue {
    forms: Array<Form> = [];

    mounted() {
        axios
            .get('/api/forms/get-all')
            .then((response) => {
                this.forms = response.data;
            })
            .catch((e) => {
                console.log(e);
            });
    }

    openForm(uri: string) {
        this.$router.replace({ name: 'formEditor', query: { report: uri } });
    }
}
</script>

<style>
.query-window {
    height: calc(100vh - 180px);
    width: 100%;
    border: none;
}

.half-bar {
    width: 50%;
    margin: auto;
    margin-bottom: 5px;
}

.form-card-wrapper {
    height: calc(100vh - 200px);
    width: 50%;
    overflow-y: auto;
    margin: auto;
}

.form-card {
    cursor: pointer;
    border: 1px solid gray;
    margin: 5px;
    padding: 10px 20px 10px;
    box-shadow: 2px 2px 5px gray;
    background-color: #faf9f6;
}

.form-card h3 {
    margin-top: 5px;
    margin-bottom: 5px;
}

.form-card p {
    font-size: 14px;
    margin-top: 2px;
    margin-bottom: 2px;
}
</style>
